/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.8 Standard
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : timer
Version : 
Date    : 17.12.2009
Author  : rotax                           
Company : home                            
Comments: 


Chip type           : ATmega128
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 1024
*****************************************************/

#include <mega128.h> 
#include <delay.h>
#include <stdlib.h> 
#include <stdio.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x1B ;PORTA
#endasm
#include <lcd.h>

#define TIMER TCNT0 

// External Interrupt 4 service routine
interrupt [EXT_INT4] void ext_int4_isr(void)
{
// test_inter=TIMER;                    //      ?
 TIMER=0;
 
  //     
  //  
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
}

// Declare your global variables here
eeprom float test_fl=0.1;       //   ,    
int timer_tmp;
int test_inter;

void main(void)
{
// Declare your local variables here
char timer_str[3];



// Input/Output Ports initialization
PORTA=0x00;
DDRA=0x00;
PORTB=0x00;
DDRB=0x00;
PORTC=0x00;
DDRC=0x00;
PORTD=0x00;
DDRD=0x00;
PORTE=0xFF;
DDRE=0x00;
PORTF=0x00;
DDRF=0x00;
PORTG=0x00;
DDRG=0x00;

// Timer/Counter 0 initialization
ASSR=0x00;   // Clock source: TOSC1 pin 0x08
TCCR0=0x07;  // Clock value: TOSC1/8  // Mode: Normal top=FFh 0x00       
TCNT0=0x00;
OCR0=0x00;   // OC0 output: Disconnected

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// OC1C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
OCR1CH=0x00;
OCR1CL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// Timer/Counter 3 initialization
TCCR3A=0x00;
TCCR3B=0x00;
TCNT3H=0x00;
TCNT3L=0x00;
ICR3H=0x00;
ICR3L=0x00;
OCR3AH=0x00;
OCR3AL=0x00;
OCR3BH=0x00;
OCR3BL=0x00;
OCR3CH=0x00;
OCR3CL=0x00;

// External Interrupt(s) initialization
// INT4 Mode: Falling Edge
EICRA=0x00;
EICRB=0x02;
EIMSK=0x10;
EIFR=0x10;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00; //1;
ETIMSK=0x00;

// Analog Comparator initialization
ACSR=0x80;
SFIOR=0x00;

// LCD module initialization
lcd_init(16);

// Global enable interrupts
#asm("sei")
while (1)
      {
       timer_tmp=TIMER;
       itoa(timer_tmp,timer_str);
       lcd_clear(); 
       delay_ms(10);
       lcd_gotoxy(0,0);  
       delay_ms(10);
       lcd_puts(timer_str);
       delay_ms(10);
       lcd_gotoxy(0,1);
       ftoa(test_fl,1,timer_str);
       lcd_puts(timer_str); 
       test_fl=test_fl+0.1;
       delay_ms(500);
       //printf("test");     //       printf ?     int?

      };
}
